using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace csimap4
{
    public partial class FormOption : Form
    {
        public FormOption()
        {
            InitializeComponent();
        }

        private void comboSmtpSsl_SelectedIndexChanged(object sender, EventArgs e)
        {
			if(comboSmtpSsl.SelectedIndex == 0 || comboSmtpSsl.SelectedIndex == 3) 
			{
				textSmtpPort.Text = nMail.Smtp.StandardPortNo.ToString();
			}
			else
			{
				textSmtpPort.Text = nMail.Smtp.StandardSslPortNo.ToString();
			}
        }

        private void comboImap4Ssl_SelectedIndexChanged(object sender, EventArgs e)
        {
			if(comboImap4Ssl.SelectedIndex == 0 || comboImap4Ssl.SelectedIndex == 3) 
			{
				textImap4Port.Text = nMail.Imap4.StandardPortNo.ToString();
			}
			else
			{
				textImap4Port.Text = nMail.Imap4.StandardSslPortNo.ToString();
			}
        }

		public string Smtp
		{
			get
			{
				return textSmtp.Text;
			}
			set
			{
				textSmtp.Text = value;
			}
		}

		public int SmtpPort
		{
			get
			{
				return int.Parse(textSmtpPort.Text);
			}
			set
			{
				textSmtpPort.Text = value.ToString();
			}
		}

		public int SmtpSsl
		{
			get
			{
				if(comboSmtpSsl.SelectedIndex == 1)
				{
					return nMail.Smtp.SSL3;
				}
				else if(comboSmtpSsl.SelectedIndex == 2)
				{
					return nMail.Smtp.TLS1;
				}
				else if(comboSmtpSsl.SelectedIndex == 3)
				{
					return nMail.Smtp.STARTTLS;
				}
				else
				{
					return 0;
				}
			}
			set
			{
				if(value == nMail.Smtp.SSL3)
				{
					comboSmtpSsl.SelectedIndex = 1;
				}
				else if(value == nMail.Smtp.TLS1)
				{
					comboSmtpSsl.SelectedIndex = 2;
				}
				else if(value == nMail.Smtp.STARTTLS)
				{
					comboSmtpSsl.SelectedIndex = 3;
				}
				else
				{
					comboSmtpSsl.SelectedIndex = 0;
				}
			}
		}

		public int SmtpAuth
		{
			get
			{
				if(comboSmtpAuth.SelectedIndex == 3)
				{
					return nMail.Smtp.AuthCramMd5;
				}
				else
				{
					return comboSmtpAuth.SelectedIndex;
				}
			}
			set
			{
				if(value == nMail.Smtp.AuthCramMd5)
				{
					comboSmtpAuth.SelectedIndex = 3;
				}
				else
				{
					comboSmtpAuth.SelectedIndex = value;
				}
			}
		}

		public string Imap4
		{
			get
			{
				return textImap4.Text;
			}
			set
			{
				textImap4.Text = value;
			}
		}

		public int Imap4Ssl
		{
			get
			{
				if(comboImap4Ssl.SelectedIndex == 1)
				{
					return nMail.Imap4.SSL3;
				}
				else if(comboImap4Ssl.SelectedIndex == 2)
				{
					return nMail.Imap4.TLS1;
				}
				else if(comboImap4Ssl.SelectedIndex == 3)
				{
					return nMail.Imap4.STARTTLS;
				}
				else
				{
					return 0;
				}
			}
			set
			{
				if(value == nMail.Imap4.SSL3)
				{
					comboImap4Ssl.SelectedIndex = 1;
				}
				else if(value == nMail.Imap4.TLS1)
				{
					comboImap4Ssl.SelectedIndex = 2;
				}
				else if(value == nMail.Imap4.STARTTLS)
				{
					comboImap4Ssl.SelectedIndex = 3;
				}
				else
				{
					comboImap4Ssl.SelectedIndex = 0;
				}
			}
		}

		public int Imap4Port
		{
			get
			{
				return int.Parse(textImap4Port.Text);
			}
			set
			{
				textImap4Port.Text = value.ToString();
			}
		}

		public int Imap4Auth
		{
			get
			{
				if(comboImap4Auth.SelectedIndex == 2)
				{
					return nMail.Imap4.AuthCramMd5;
				}
				else
				{
					return comboImap4Auth.SelectedIndex + 1;
				}
			}
			set
			{
				if(value == nMail.Imap4.AuthCramMd5)
				{
					comboImap4Auth.SelectedIndex = 2;
				}
				else if(value > 0) 
				{
					comboImap4Auth.SelectedIndex = value - 1;
				}
				else
				{
					comboImap4Auth.SelectedIndex = 1;
				}
			}
		}

		public string Address
		{
			get
			{
				return textAddress.Text;
			}
			set
			{
				textAddress.Text = value;
			}
		}
    }
}